setInfos(9, "theEdger-stop", "An edging script with pictures", "NIFOC99", "v2.1", 0xde5d83, "en", ["edging", "exhibition", "formale", "internet"]);
// v0.1 first release
// v0.2 2s wait before picture
// v0.3 sounds added
// v0.4 simplified voting, reduced calls to server (watch) changes to array lengths (go and stop) don't throw women out (not really fair!)
// v1.0 check for blank pictures, added quit to watch, first stable version
// v1.1 allow for android in picBlank (theEdger.groovy)
// v1.2 check for blank pictures
// v1.3 changes to stored pics (codeB) to prevent multiple posting
// v1.4 no changes here
// v2.1 title added, server access rewritten, file-based messages, progress bar

def Title = "<h1 style='font-size:140%;'>theEdger</h1><p>"

//Get basic info about player

def FileStart = loadString("theEdger.FileStart")
def FileMax = loadInteger("theEdger.FileMax")

def PicCodeA, PicCodeB, PicCodeBChars, PicCodeP, PicCodeQ, PicCodeQChars, PicNumber, NumberPics, PicKey

def PicCodeMax = 50

def ProbNoGauge = 5 //Percent

//Closures (functions)########################################################################################

def picBlank = {def  pic -> //checks if picture is blank (all the same colour)----------------------------------

	if (getDataFolder().toLowerCase().contains("android")) { return false } //don't try with android

	def image = javax.imageio.ImageIO.read(new File(pic))
	int width = image.getWidth()
	int height = image.getHeight()
	if(width<90||height<90) { return true } //might as well be blank

	def a = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def r = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def g = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def b = [0, 0, 0, 0 ,0 ,0 ,0 ,0 ,0 ,0]
	def asum = 0; def rsum = 0; def gsum = 0; def bsum = 0
	

	for (def k = 0; k < 10; k++) {
		int x = getRandom(width)
		int y = getRandom(height)
		int p = image.getRGB(x, y)
		a[k] = (p>>24) & 0xff; r[k] = (p>>16) & 0xff; g[k] = (p>>8) & 0xff; b[k] = p & 0xff
		asum = asum+a[k]; rsum = rsum+r[k]; gsum = gsum+g[k]; bsum = bsum+b[k]		
	}
	def aave = asum/10; def rave = rsum/10; def gave = gsum/10; def bave = bsum/10

	def astd = 0; def rstd = 0; def gstd = 0; def bstd = 0

	for (def k = 0; k < 10; k++) {
		astd = astd+(a[k]-aave)*(a[k]-aave)
		rstd = rstd+(r[k]-rave)*(r[k]-rave)
		gstd = gstd+(g[k]-gave)*(g[k]-gave)
		bstd = bstd+(b[k]-bave)*(b[k]-bave)
	}
	astd = Math.sqrt(astd); rstd = Math.sqrt(rstd); gstd = Math.sqrt(gstd); bstd = Math.sqrt(bstd)

	if(astd<50&&rstd<50&&gstd<50&&bstd<50) { return true }
	else { return false }
}

def getCodes = {C -> //---------------------------------------------------------------------------------------
	def S1 = 0; def S2 = 0; def PList = []
	for(def i=0; i<C.count("|"); i++) {
		S2 = C.indexOf("|", S1)
		PList << C.substring(S1, S2)
		S1 = S2+1
	}
	return PList
}

def ProgressBar = {c, t, g ->//-------------------------------------------------------------------------------
	def t1 = t/30
	def t2 = 0
	def t3 = false
	if(getRandom(2)==0) {t3 = true}
	for(def i=0; i<30; i++) {
		t2 = t2+t1
		if(t3&&t2>2) {//take picture
			PicCodeB = loadString("theEdger.PicCodeB")//player pictures codes
			PicCodeBChars = PicCodeB.toCharArray()
			PicNumber = PicCodeB.indexOf("0")
			if(PicNumber<0) {PicNumber = getRandom(PicCodeMax)}
			PicCodeA = getImage("")
			if(PicCodeA.indexOf("captured")>=0) {//Check not fake
				save("theEdger.PicCodeA"+PicNumber, PicCodeA)
				save("theEdger.LatestPic", PicCodeA)
				PicCodeBChars[PicNumber]="1"
				PicCodeB = String.valueOf(PicCodeBChars)
				save("theEdger.PicCodeB", PicCodeB)
				t3 = false
			}
		}
		def m = "<font color='blue'>"
		if(!g) {m = m+"I'm not telling you how long! <b>Just wait!</b></font>"}
		else {
			for(def j=0; j<30; j++) {
				if(j==i+1) {m = m+"</font><font color='white'>"}
				m = m+"█"
			}
			m = m+"</font>"
		}
		show(c+"<p style='font-size:80%;text-align:center;'>"+m+"</p>")
		wait(t1)
	}
	return
}

def ShowPic = {
	switch(FileMax) {
		case 0:
			return
		case 1:
			def EdgerPath = getDataFolder().replaceAll("\\\\", "/")+"images/theEdger/user/"
			def EdgerFiles = []
			new File(EdgerPath).eachFile() {file->
				if(file.isFile()&&(file.getAbsolutePath().indexOf(".jpg")>0||
					file.getAbsolutePath().indexOf(".jpeg")>0||
					file.getAbsolutePath().indexOf(".gif")>0||
					file.getAbsolutePath().indexOf(".png")>0)) {
					EdgerFiles << file.getAbsolutePath()
				}
			}
			setImage(EdgerFiles[getRandom(EdgerFiles.size)])
			return
		case 2:
			setImage(loadString("theEdger.LatestPic"))
			return
	}
}

//End of closures (functions)---------------------------------------------------------------------------------

//Start ######################################################################################################

setImage(null)

def StopLines = new File("scripts/theEdger/theEdger-stop.txt").readLines()
def StopList = getCodes(StopLines[getRandom(StopLines.size)])
//message|time|min time|soundfile|

def StopMessage = "<p style='font-size:120%;'>"+StopList[0]+"</p>"

def TargetDuration = loadInteger("theEdger.TargetDuration")
def Elapsed = loadInteger("theEdger.Elapsed")-(StopList[1] as Integer)

def TargetMultiplier = loadFloat("theEdger.TargetGoMultiplier")*loadFloat("theEdger.TargetStopMultiplier")
def SpeedMessage = ""
if (Elapsed<TargetDuration/4) {
	TargetMultiplier = TargetMultiplier/4;
	SpeedMessage = "<p>This is the final phase, you may be allowed to cum any moment now!</p>";
} else if (Elapsed<TargetDuration/2) {
	TargetMultiplier = TargetMultiplier/2;
	SpeedMessage = "<p>The game will go faster now, remember NOT to cum yet!</p>";
}

ShowPic()

def WaitTime = [(StopList[1] as Integer)*TargetMultiplier, (StopList[2] as Integer)].max()

if(StopList[3]!="-1") {playBackgroundSound("theEdger/"+FileStart+"_"+StopList[3]+".mp3")}
ProgressBar(Title+StopMessage+SpeedMessage, WaitTime, getRandom(100)>ProbNoGauge)

save("theEdger.Elapsed", Elapsed)
return "theEdger/theEdger-go.groovy"

// This script, from https://ss.deviatenow.com, is the copyright of the author
// copyright restrictions will be relaxed on future (stable) versions
