setInfos(9, "theEdger-watch", "An edging script with pictures", "NIFOC99", "v2.1", 0xC0C0C0, "en", ["edging", "exhibition", "formale", "internet"]);
// v0.1 first release
// v0.2 trap PicCodeP not containing ".jpg"
// v0.3 added function showSImage taken from "Mandy Review" by "Liz"
// v0.4 simplified voting, reduced calls to server
// v1.0 check for blank pictures, added quit to watch, first stable version
// v1.1 allow for android in picBlank (theEdger.groovy)
// v1.2 ?? (not NIFOC99)
// v1.3 changes to stored pics (codeB) to prevent multiple posting
// v1.4 no changes here
// v2.1 title added, server access rewritten

def Title = "<h1 style='font-size:140%;'>theEdger</h1><p><p>"
def PicCodeA, PicCodeB, PicCodeBChars, PicCodeQChars, PicCodeR, PicCodeS
def PicNumberB, PicNumber, NumberPics, PicKey, PicVote, PicMessage, MissLen
def PicNumCode = [], PicKeyCode = [], PlCodeCode = [], PlNameCode = []

//Get basic info about player

def PlayerName = loadString("intro.name")
def PlayerCode = loadInteger("theEdger.PlayerCode")
if(PlayerCode==null) {
	PlayerCode = getRandom(1000000)
	save("theEdger.PlayerCode",PlayerCode)
	}
def NumberStarts = loadInteger("theEdger.NumberStarts")

def PicCodeMax = 50

def Answer

//Closures (functions)##########################################################################################

def showSImage = {sicode -> // Only download pic if not already downloaded--------------------------------------
	def sipic = null
	if (sicode != null) {
		try {
			if (new File("images/"+sicode).exists())
			  sipic = sicode
			else 
			  sipic = receiveImage(sicode)
		}
		catch(def e1) {}
	}
	setImage(sipic) 
}

def getCodes = {C -> //---------------------------------------------------------------------------------------
	def S1 = 0; def S2 = 0; def PList = []
	if(C!=null) {
		for(def i=0; i<C.count("|"); i++) {
			S2 = C.indexOf("|", S1)
			PList << C.substring(S1, S2)
			S1 = S2+1
		}
	}
	return PList
}

def makeCode = {def Ltext ->//--------------------------------------------------------------------------------
	def t = ""
	for(def k=0; k<Ltext.size(); k++) {t = t+Ltext[k]+"|"}
	return t		
}

def SendPic = {A ->//-----------------------------------------------------------------------------------

	MissLen = 0
	PicNumCode = getCodes(receiveString("theEdger.PicNumText")?: "")
	if(PicNumCode!=[]) {MissLen = PicCodeMax-PicNumCode.size()}
	else {MissLen = PicCodeMax}
	if(MissLen>0) {for(def j=0; j<MissLen; j++) {PicNumCode << "0"}}
	PicKeyCode = getCodes(receiveString("theEdger.PicKeyText")?: "")
	if(PicKeyCode!=[]) {MissLen = PicCodeMax-PicKeyCode.size()}
	else {MissLen = PicCodeMax}
	if(MissLen>0) {for(def j=0; j<MissLen; j++) {PicKeyCode << ""}}
	PlCodeCode = getCodes(receiveString("theEdger.PlCodeText")?: "")
	if(PlCodeCode!=[]) {MissLen = PicCodeMax-PlCodeCode.size()}
	else {MissLen = PicCodeMax}
	if(MissLen>0) {for(def j=0; j<MissLen; j++) {PlCodeCode << ""}}
	PlNameCode = getCodes(receiveString("theEdger.PlNameText")?: "")
	if(PlNameCode!=[]) {MissLen = PicCodeMax-PlNameCode.size()}
	else {MissLen = PicCodeMax}
	if(MissLen>0) {for(def j=0; j<MissLen; j++) {PlNameCode << ""}}

	PicNumber = PicNumCode.indexOf("0") //Free slot
	if(PicNumber<0) {PicNumber = getRandom(PicCodeMax)} //or random
	PicNumCode[PicNumber] = "3"
	PicKeyCode[PicNumber] = sendImage(A)
	PlCodeCode[PicNumber] = PlayerCode
	PlNameCode[PicNumber] = PlayerName

	send("theEdger.PicNumText", makeCode(PicNumCode))
	send("theEdger.PicKeyText", makeCode(PicKeyCode))
	send("theEdger.PlCodeText", makeCode(PlCodeCode))
	send("theEdger.PlNameText", makeCode(PlNameCode))
			
}

//End of closures (functions)---------------------------------------------------------------------------------

//Start ######################################################################################################

setImage("theEdger/theEdger001.jpg")
show(Title+"Pictures may take some time to download.")
wait(1)

//Check if player is connected.

if(!isConnected()) {
	setImage("theEdger/theEdger002.jpg") 
	show(Title+"Sorry. You're not connected to the internet. You can't view pictures on the server")
	showButton("Bye")
	setImage(null) 
	show(null) //clear screen
	return null //stop script
}

// Unless newish player, it costs a picture
if(NumberStarts>4) {
	if(!getBoolean(Title+"Looking at the players means you have to contribute one of your own.", "Agree", "Refuse")) {
		setImage(null)
		show(null)
		return "theEdger"
	}
//Pictures
	show(Title+"You are paying the price - wait.")
	wait(1)

	PicCodeB = loadString("theEdger.PicCodeB")
	PicCodeBChars = PicCodeB.toCharArray()
	PicNumberB = PicCodeB.indexOf("1") //A picture
	if(PicNumberB>=0) {//Only if there are pics
		PicCodeA = loadString("theEdger.PicCodeA"+PicNumberB)?: "temp"

		SendPic(PicCodeA)		

		PicCodeBChars[PicNumberB] = "0"
		PicCodeB = String.valueOf(PicCodeBChars)
		save("theEdger.PicCodeB", PicCodeB)
		save("theEdger.PicCodeA"+PicNumberB, null)
	}
	else {
		show(Title+"<p>You don't have any pictures to contribute.</p><p>Play a few games and try again")
		showButton("Bye")
		setImage(null)
		return "theEdger"
	}
}

MissLen = 0
PicNumCode = getCodes(receiveString("theEdger.PicNumText")?: "")
if(PicNumCode!=[]) {MissLen = PicCodeMax-PicNumCode.size()}
else {MissLen = PicCodeMax}
if(MissLen>0) {for(def j=0; j<MissLen; j++) {PicNumCode << "0"}}
PicKeyCode = getCodes(receiveString("theEdger.PicKeyText")?: "")
if(PicKeyCode!=[]) {MissLen = PicCodeMax-PicKeyCode.size()}
else {MissLen = PicCodeMax}
if(MissLen>0) {for(def j=0; j<MissLen; j++) {PicKeyCode << ""}}
PlCodeCode = getCodes(receiveString("theEdger.PlCodeText")?: "")
if(PlCodeCode!=[]) {MissLen = PicCodeMax-PlCodeCode.size()}
else {MissLen = PicCodeMax}
if(MissLen>0) {for(def j=0; j<MissLen; j++) {PlCodeCode << ""}}
PlNameCode = getCodes(receiveString("theEdger.PlNameText")?: "")
if(PlNameCode!=[]) {MissLen = PicCodeMax-PlNameCode.size()}
else {MissLen = PicCodeMax}
if(MissLen>0) {for(def j=0; j<MissLen; j++) {PlNameCode << ""}}
		
NumberPics = 0
for(def k=0; k<PicCodeMax; k++) {if(PicNumCode[k]!="0"&&PicNumCode[k]!="1") {NumberPics++}}

PicNumber = 0
//Go through pictures on server
for (def i=0 ; i<PicCodeMax; i++) {
	int s = PicNumCode[i] as Integer
	int t = PlCodeCode[i] as Integer
	if(PicKeyCode[i]==null) {PicNumCode[i] = "0"} //if key is null
	if(s>1) {
		PicNumber++
		PicMessage = Title+"<p>Picture "+PicNumber+" of "+NumberPics+"</p><p>This is "+PlNameCode[i]
		PicKey = receiveImage(PicKeyCode[i])
		showSImage(PicKey)

		if(PlayerCode==t||s>4) {
			Answer = getSelectedValue(PicMessage, ["OK", "Quit"]) //Don't get to vote
			Answer++ //2 means quit
		}
		else {
			Answer = getSelectedValue(PicMessage+"<p>Is this a good picture?", ["Yes", "No", "Quit"])
			if(Answer==0) {s++}
			else if(Answer==1) {s--}
			if(s<2) {s = 0}
			if(s>4) {s = 5}
			PicNumCode[i] = s as String
		}
	}
	if(Answer==2) {i=PicCodeMax}
}

send("theEdger.PicNumText", makeCode(PicNumCode))

return "theEdger"

// This script, from https://ss.deviatenow.com, is the copyright of the author
// copyright restrictions will be relaxed on future (stable) versions
